<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->

<script setup lang="ts">
import { inject, ref } from 'vue';
import { storeToRefs } from 'pinia';
import Modal from '@/components/general/Modal.vue';
import Input from '@/components/general/form/Input.vue';
import { request } from '@/lib/request';
import { useAccountStore } from '@/stores/account';


const emits = defineEmits<{
    (e: 'close'): void,
    (e: 'success'): void
}>();

const store = useAccountStore();
const { accesscode: accountAccesscode } = storeToRefs(store);

const accesscode = ref(accountAccesscode.value);
const showError = ref(false);
const configuration = inject<any>('configuration');
const getAccessCodeFinderURL = configuration.accessCode.finderURL;
const getAccessCodeFinderLabel = configuration.accessCode.finderLabel;

const submit = async () => {
    if (accesscode.value) {
        let response = await request('POST', configuration.apiServer + '/api/account/profile',
            { accesscode: accesscode.value }, 'application/json', false, true);
        if (response && response.success) {
            accountAccesscode.value = accesscode.value;
            cancel();
        } else {
            showError.value = true;
        }
    }
}

const cancel = async () => {
    emits('close');
}

</script>
<template>
    <Modal :header="$t('general.variables.account.sg') + ' ' + $t('general.variables.change')"
        :labelCancel="$t('general.buttons.cancel')" :labelSubmit="$t('general.buttons.send')"
        :disableSubmit="accesscode.length < 1" @submit="submit" @cancel="cancel">
        <Input v-model="accesscode" type="text" size="w-full" :placeholder="$t('general.variables.accesscode')"
            icon="home-2" :label="$t('general.variables.accesscode')" />
        <div class="mt-4" v-if="getAccessCodeFinderURL && getAccessCodeFinderLabel">
            <a class="text-center align-middle mx-auto w-full block" :href="getAccessCodeFinderURL" target="_blank"
                rel="noopener">{{ getAccessCodeFinderLabel }}</a>
        </div>
    </Modal>
</template>